if not shieldStorageCfg then rawset(_G, "shieldStorageCfg", {}) end
shieldStorageCfg.version = "2.1"

local function getShieldList()
    local ret_table = {
        --[[ this hellspawn:
            I caved in and decided to use constants instead. It reads like crap, specially since I need the keys to be strings, hence the tostring() conversion,
            but I guess this is gonna make things easier (for me) in the long run. 
            For readers: I am sorry.]]
        [tostring(SH_NONE)]        = {'No Shield',         SH_NONE,        'No description.', 'NO ICON',  sfx_None  },
        [tostring(SH_PITY)]        = {'Pity Shield',       SH_PITY,        'No description.', 'TVPIICON', sfx_shield},
        [tostring(SH_WHIRLWIND)]   = {'Whirlwind Shield',  SH_WHIRLWIND,   'No description.', 'TVWWICON', sfx_wirlsg},
        [tostring(SH_ARMAGEDDON)]  = {'Amargeddon Shield', SH_ARMAGEDDON,  'No description.', 'TVARICON', sfx_armasg},
        [tostring(SH_PINK)]        = {'Pink Shield',       SH_PINK,        'No description.', 'TVPPICON', sfx_shield},
        [tostring(SH_ELEMENTAL)]   = {'Elemental Shield',  SH_ELEMENTAL,   'No description.', 'TVELICON', sfx_elemsg},
        [tostring(SH_ATTRACT)]     = {'Attraction Shield', SH_ATTRACT,     'No description.', 'TVATICON', sfx_attrsg},
        [tostring(SH_FLAMEAURA)]   = {'Flame Shield',      SH_FLAMEAURA,   'No description.', 'TVFLICON', sfx_s3k3e },
        [tostring(SH_BUBBLEWRAP)]  = {'Bubble Shield',     SH_BUBBLEWRAP,  'No description.', 'TVBBICON', sfx_s3k3f },
        [tostring(SH_THUNDERCOIN)] = {'Lightning Shield',  SH_THUNDERCOIN, 'No description.', 'TVZPICON', sfx_s3k41 },
        [tostring(SH_FORCE)]       = {'Force Shield',      SH_FORCE,       'No description.', 'TVFOICON', sfx_frcssg}
    }

    --[[ compatibility:
        Gonna read a text file for added compatibility for custom shields.
        io.openlocal() leaves me antsy considering it can cause desyncs on multiplayer but I think if I'm shoving the result table of this function inside
        a global variable it should avoid synchroniztion issues.]]
    if shieldStorageCfg.shieldListFilename == "" then return ret_table end
    local file_handle = io.openlocal("client/Shield Storage/" .. shieldStorageCfg.shieldListFilename, "r")
    if not file_handle then return ret_table end
    while true do
        local new_entry = {}
        local line = file_handle:read()

        if line == nil then break end

        for v in line:gmatch("([^,]+)") do
            table.insert(new_entry, v)
        end

        --[[ addressing the global namespace:
            This looks very cursed and I don't even know if it's something I'm supposed to be doing, well,
            if I wanna be able to convert string names into constants, we have to do this.]]
        new_entry[2] = _G[new_entry[2]]  
        new_entry[5] = _G[new_entry[5]]

        ret_table[tostring(new_entry[2])] = new_entry
    end
    file_handle:close()
    return ret_table
end
rawset(_G, "getShieldList", getShieldList)



shieldStorageCfg.RING_COST = 5
shieldStorageCfg.shieldListFilename = ""
shieldStorageCfg.shieldTable = getShieldList()
shieldStorageCfg.RESET_ON_SPAWN_LEVELCOMPLETE = true

print("\n\130Shield Storage \128v\132" .. shieldStorageCfg.version .. " \128by \137Labyrinthia\n")