COM_AddCommand("SS_SetCustomList", function(player, filename)
    if not filename then
        CONS_Printf(player, "\130No arguments provided. Please specify the filename of the custom list")
    end
    shieldStorageCfg.shieldListFilename = filename
    CONS_Printf(player, "\131Custom list set!")
end)

COM_AddCommand("SS_ResetOnLevelEnd", function(player, OnOff)
    if not OnOff then
        CONS_Printf(player, "\130No arguments provided. Please specify one of the two possible arguments: (On, Off).")
        return
    end
    
    local OnOffTable = {
        ["ON"]  = 1,
        ["OFF"] = 2
    }

    OnOff = OnOffTable[OnOff:upper()]

    if OnOff == 1 then 
        shieldStorageCfg.RESET_ON_SPAWN_LEVELCOMPLETE = true
        OnOff = "True"
    elseif OnOff == 2 then
        shieldStorageCfg.RESET_ON_SPAWN_LEVELCOMPLETE = false
        OnOff = "False"
    else
        CONS_Printf(player, "\130Invalid Argument. Are you sure you passed On or Off?")
        return
    end
    print("\131SS_ResetOnLevelEnd was set to " .. OnOff .. "!")
end, COM_ADMIN)

COM_AddCommand("SS_ReloadShieldList", function(player)
    shieldStorageCfg.shieldTable = getShieldList()
    print("\131Shield list reloaded!")
end, COM_ADMIN)

COM_AddCommand("SS_SetRingCost", function(player, ringAmount, silent)
    if not ringAmount then
        CONS_Printf(player, "\130No arguments provided. Please specify a ring amount.")
        return
    elseif not tonumber(ringAmount) then
        CONS_Printf(player, "\130Unexpected argument. Are you sure you passed a number?")
        return
    elseif tonumber(ringAmount) < 0 then
        CONS_Printf(player, "\130Ring amount can't be less than 0.")
        return
    end

    shieldStorageCfg.RING_COST = tonumber(ringAmount)

    print("\131Ring cost for switching/summoning shields set to " .. ringAmount)
end, COM_ADMIN)