-- main function
local function shieldWorker(player)
    --[[ player properties: 

        Create the necessary player properties. In the original script I was a dumbass and for some reason thought
        having a bajillion variables in the outer scope for everything was a smart idea, but that just meant that it
        couldn't be used for multiplayer gamemodes (on top of looking horrible). I'm still not sure if I'm gonna bother 
        making this netplay compatible but at least I wanna make things the right way.]]
    if not player.shieldstorage then player.shieldstorage = {} end
    if not player.shieldstorage_index then player.shieldstorage_index = 1 end

    --[[ checking button presses: 

        I'll be using l_ButtonState.lua to validate button presses because, in all honesty, this is way better than anything
        I could ever come up with and I simply cannot be bothered.
        
        On a side-note: 
        I got this (script is way down there) from https://github.com/sprkizard/srb2-lua-lib/blob/master/player/l_ButtonState.lua 
        and I have no idea why it's in a github repo instead of the forums, I mean I appreciate the idea but, is there
        any specific reason why???]]
    if player.buttonstate[BT_WEAPONPREV] == 1 then
        if player.shieldstorage_index >= #player.shieldstorage then
            player.shieldstorage_index = 1
        else
            player.shieldstorage_index = player.shieldstorage_index + 1
        end
        if #player.shieldstorage >= 2 then
            S_StartSound(nil, sfx_wepchg, player)
        end
    elseif player.buttonstate[BT_WEAPONNEXT] == 1 then
        if player.shieldstorage_index <= 1 then
            player.shieldstorage_index = max(1, #player.shieldstorage)
        else
            player.shieldstorage_index = player.shieldstorage_index - 1
        end
        if #player.shieldstorage >= 2 then
            S_StartSound(nil, sfx_wepchg, player)
        end
    end

    if player.buttonstate[BT_CUSTOM1] == 1 then
        A_StoreShield(player.mo, player.powers[pw_shield], nil)
    end
    if player.buttonstate[BT_CUSTOM2] == 1 then
        if player.rings >= shieldStorageCfg.RING_COST then
            if player.shieldstorage[player.shieldstorage_index] then
                local shieldObj = player.shieldstorage[player.shieldstorage_index]
                table.remove(player.shieldstorage, player.shieldstorage_index)
                if player.shieldstorage_index > #player.shieldstorage then
                    player.shieldstorage_index = #player.shieldstorage
                end
                player.mo.target = player.mo
                A_SummonShield(player.mo, shieldObj.decimalValue, shieldObj.sfx)
                player.rings = player.rings - shieldStorageCfg.RING_COST
            end
        end
    end
end
addHook("PlayerThink", shieldWorker)

-- function to clear the player's stored shields on death.
local function begoneShield(target, inflictor, source, damagetype)
    target.player.shieldstorage = {}
    target.player.shieldstorage_index = 1
    return false
end
addHook("MobjDeath", begoneShield, MT_PLAYER)

-- function to clear the player's stored shields on spawn.
local function resetShield(player)
    if shieldStorageCfg.RESET_ON_SPAWN_LEVELCOMPLETE == true then 
        player.shieldstorage = {}
        player.shieldstorage_index = 1
    end
end
addHook("PlayerSpawn", resetShield)

-- sync up the options with the host when a player joins the netgame
local function joinSyncInfo(network)
    shieldStorageCfg = network(shieldStorageCfg)
end
addHook("NetVars", joinSyncInfo)