--[[ shieldLookup() explanation: 

    Since I decided to be a butt and have the possibility to include "fancy" names and descriptions to each shield, I'd have to either
    set them up individually each time I checked the shield's value (I'm using constants now!!), 
    which I honestly hate thinking about. So instead I decided to use a lookup table to do the same thing but in an arguably 
    more concise way, so if I wanna add more useless flair to this later, it won't be THAT much of a pain. 
    
    Me from a literal day later:
    I'm so glad I did it this way, this made working with the TV boxes icons and sfx for each shield so much easier.]]
local function shieldLookup(decimalValue)
    local lookupTable = shieldStorageCfg.shieldTable

    --[[ this goddamn wizardry explanation: 
        
        You might be wondering: "What the HELL is going on here?" Well, this is all because of Force Shield.
        Simply because the 256 decimal value is equivalent to Force Shield with only 1 HP left, and its 2 HP "variant" has a 
        decimal value of 257, following that logic, decimal values from 258 onwards (from my experimentation), will add another
        hitpoint to the Force Shield until it hits 1025, which is the decimal value for the Flame Shield (it probably actually has an
        upper limit lower than that but you're crazy if you think I'll be checking values 258 — 1024 ONE BY ONE to confirm my speculations).
        
        So the way that I work around that is simply assuming that any decimal value that isn't on the table will be just another Force Shield with
        some bigass HP value, so when the game tries to index the lookupTable with it, it'll return nil, this default value will be assigned to it instead.]]
    local shieldInfo = lookupTable[tostring(decimalValue)] or {'Force Shield', decimalValue, 'No description.', 'TVFOICON', sfx_forcsg}
    return shieldInfo
end

--[[ ShieldObj... object:
    I'm mostly updating this old thing because I've been reminiscing about old things and I have a small interest in playing
    around with object oriented programming in Lua. The old script only worked the way it did because I had no idea how to
    actually store shields in a similar way to how it works with Mighty in Sonic Megamix (which was the inspiration for this addon),
    and I'm going to change that this time by applying the power of object orientation and a semi-lethal dosage of caffeine and breakcore.
    ...and cursing at my screen when something doesn't work.]]

local ShieldObj = {
    name = 'Shieldless? :megamind:',
    decimalValue = 0,
    desc = 'L + Ratio + No emeralds + You fell off + Touch greenflower zone + That\'s why Greenflower City was destroyed',
    icon = 'SOMETHING_ICON',
    sfx = sfx_None
}
function ShieldObj:new(obj, shieldDecimal)
    obj = obj or {}
    obj.name, obj.decimalValue, 
    obj.desc, obj.icon, 
    obj.sfx = unpack(shieldLookup(shieldDecimal))
    
    setmetatable(obj, ShieldObj)
    self.__index = self
    return obj
end
rawset(_G, "ShieldObj", ShieldObj)